
// (c) by Heinrich Tillack 2002 (http://a128.x15.org)
// under GPL or new BSD license


#ifndef __UTILS_H
#define __UTILS_H

#include <kos.h>


#define mat_veq(x, y, z) ({ \
	register float __x __asm__("fr0") = (x); \
	register float __y __asm__("fr1") = (y); \
	register float __z __asm__("fr2") = (z); \
	register float __result __asm__("fr3"); \
	__asm__ __volatile__( \
		"fldi0	fr3\n" \
		"fipr	fv0,fv0\n" \
		"fsqrt	fr3\n" \
		: "=f" (__result) \
		: "f" (__x), "f" (__y), "f" (__z) \
		); \
	__result; \
})

/* load a binary file into a texture */
void bin_to_texture(char *filename, uint32 tex, int w, int h);

/* Load a texture using pcx_load_texture and twiddle it */
void pcx_to_txr(const char *fn, uint32 *tex_out,int *tsize) ;


void jpeg_to_txr(const char * filename, uint32* tex_out,
                 int alpha,int twiddle, int scale, int *tsize);

int randnum(int limit);
int rand();

void my_memclear(char *ptr,int size);



#endif

